'use strict';

let config = void 0;
const replaceMatched = (code, _id) => {
  const env = config.env;
  code = code.replace(
    /^.*?#v-if(n?)def\s*(\S+).*[\r\n]{1,2}([\s\S]+?)\s*.*?#v-endif.*?$/gm,
    (_, $1, $2, $3) => {
      const isNot = !!$1;
      const isKeep = $2.split("||").some((v) => {
        let flag = false;
        const [key, value] = v.split("=");
        if (value === void 0) {
          flag = !!env[key];
        } else {
          flag = String(env[key]) === value;
        }
        flag = isNot ? !flag : flag;
        return flag;
      });
      return isKeep ? $3 : "";
    }
  );
  return {
    code,
    map: null
  };
};
const VitePluginConditionalCompile = () => {
  return {
    name: "vite-plugin-conditional-compile",
    enforce: "pre",
    configResolved(_config) {
      config = _config;
    },
    transform(code, id) {
      return replaceMatched(code);
    }
  };
};

module.exports = VitePluginConditionalCompile;
